"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_data_evaluate_expression
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_data_evaluate_expression class methodsFor:'documentation'!

documentation
"
The `-data-evaluate-expression' Command
---------------------------------------

Synopsis
........

      -data-evaluate-expression EXPR

   Evaluate EXPR as an expression.  The expression could contain an
inferior function call.  The function call will execute synchronously.
If the expression contains spaces, it must be enclosed in double quotes.

{No value for `GDBN'} Command
.............................

The corresponding {No value for `GDBN'} commands are `print', `output',
and `call'.  In `gdbtk' only, there's a corresponding `gdb_eval'
command.

Example
.......

In the following example, the numbers that precede the commands are the
'tokens' described in *note GDB/MI Command Syntax: GDB/MI Command
Syntax.  Notice how GDB/MI returns the same tokens in its output.

     211-data-evaluate-expression A
     211^done,value='1'
     (gdb)
     311-data-evaluate-expression &A
     311^done,value='0xefffeb7c'
     (gdb)
     411-data-evaluate-expression A+3
     411^done,value='4'
     (gdb)
     511-data-evaluate-expression 'A + 3'
     511^done,value='4'
     (gdb)


"
! !

!GDBMI_data_evaluate_expression methodsFor:'accessing'!

operation
	^ 'data-evaluate-expression'
! !

