"{ Package: 'jv:libgdbs' }"

"{ NameSpace: Smalltalk }"

GDBDebuggerObject subclass:#GDBTransientObject
	instanceVariableNames:'stateSequenceNumber'
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core'
!

!GDBTransientObject class methodsFor:'testing'!

isAbstract
    ^ self == GDBTransientObject
! !

!GDBTransientObject methodsFor:'initialization'!

debugger: aGDBDebugger
    self assert: (debugger isNil or:[ debugger == aGDBDebugger ]).
    debugger := aGDBDebugger.
    stateSequenceNumber := debugger currentInferiorStateSequnceNumber

    "Created: / 27-02-2015 / 15:10:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 27-02-2015 / 17:22:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBTransientObject methodsFor:'private'!

ensureIsValid
    self isValid ifTrue:[
        (GDBInvalidObject newException)
            parameter:self;
            messageText:'Invalid object (thread resumed)';
            raise.
    ].

    "Created: / 07-09-2014 / 23:08:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBTransientObject methodsFor:'testing'!

isValid
    ^ debugger currentInferiorStateSequnceNumber ~~ stateSequenceNumber
! !

